"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = Button;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _AppContext = require("../AppContext");

var _transition = require("../../utilities/transition");

var _Spinner = require("../Spinner");

var _Link = require("../Link");

var _legacy = require("../../utilities/legacy");

var _mediaQuery = require("../../utilities/media-query");

var _Connected = require("../Connected");

var _Button = _interopRequireDefault(require("./Button.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Button(_ref) {
  var children = _ref.children,
      _ref$submit = _ref.submit,
      submit = _ref$submit === void 0 ? false : _ref$submit,
      disabled = _ref.disabled,
      onPress = _ref.onPress,
      to = _ref.to,
      subdued = _ref.subdued,
      plain = _ref.plain,
      secondary = _ref.secondary,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      _ref$fill = _ref.fill,
      fill = _ref$fill === void 0 ? false : _ref$fill,
      loadingLabel = _ref.loadingLabel;
  var href = disabled ? undefined : to;
  var onClick = disabled ? undefined : function () {
    return onPress === null || onPress === void 0 ? void 0 : onPress();
  };
  var translate = (0, _AppContext.useTranslate)();
  var prefersReducedMotion = (0, _mediaQuery.usePrefersReducedMotion)();
  var transition = (0, _transition.useTransition)(loading, {
    enter: 'slow'
  });
  var connected = (0, _Connected.useConnected)();
  var classes = (0, _cssUtilities.classNames)(_Button["default"].Button, _legacy.button, subdued && _Button["default"].isSubdued, plain && _Button["default"].isPlain, disabled && _Button["default"].isDisabled, loading && _Button["default"].isLoading, fill && _Button["default"].isFill, _Button["default"][(0, _cssUtilities.variationName)('isLoading-transition', transition)], connected && _Button["default"].isConnected, secondary && _Button["default"].isSecondary);

  var content = /*#__PURE__*/_react["default"].createElement("span", {
    className: _Button["default"].Content
  }, children);

  var type = submit ? 'submit' : 'button';

  var loadingMarkup = /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _cssUtilities.classNames)(_Button["default"].LoadingContent, !prefersReducedMotion && _Button["default"].Spinner)
  }, /*#__PURE__*/_react["default"].createElement(_Spinner.Spinner, {
    size: "small",
    color: "inherit"
  }, loadingLabel ? loadingLabel : translate('processing')));

  if (href) {
    return /*#__PURE__*/_react["default"].createElement(_Link.UnstyledLink, {
      to: href,
      className: classes,
      onPress: onPress
    }, content, loading && loadingMarkup);
  }

  return /*#__PURE__*/_react["default"].createElement("button", {
    type: type,
    className: classes,
    disabled: disabled || loading,
    onClick: onClick,
    "aria-busy": loading
  }, content, loading && loadingMarkup);
}