"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CalloutHeader = CalloutHeader;
exports.CheckmarkCircleIcon = CheckmarkCircleIcon;
exports.CancelledCircleIcon = CancelledCircleIcon;
exports.WarningCircleIcon = WarningCircleIcon;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _CalloutHeader = _interopRequireDefault(require("./CalloutHeader.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var STATUS_ICONS = {
  success: /*#__PURE__*/_react["default"].createElement(CheckmarkCircleIcon, null),
  cancelled: /*#__PURE__*/_react["default"].createElement(CancelledCircleIcon, null),
  warning: /*#__PURE__*/_react["default"].createElement(WarningCircleIcon, null)
};

function CalloutHeader(_ref) {
  var children = _ref.children,
      status = _ref.status,
      _ref$animated = _ref.animated,
      animated = _ref$animated === void 0 ? true : _ref$animated;
  var className = (0, _cssUtilities.classNames)(_CalloutHeader["default"].CalloutHeader, _defineProperty({}, _CalloutHeader["default"].Animated, animated));
  return /*#__PURE__*/_react["default"].createElement("header", {
    className: className
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _CalloutHeader["default"].CalloutHeaderStatus
  }, STATUS_ICONS[status]), /*#__PURE__*/_react["default"].createElement("div", {
    className: _CalloutHeader["default"].CalloutHeaderContent
  }, children));
}

function CheckmarkCircleIcon() {
  return /*#__PURE__*/_react["default"].createElement("svg", {
    width: "50",
    height: "50",
    viewBox: "0 0 50 50",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M49 25C49 38.2548 38.2548 49 25 49C11.7452 49 1 38.2548 1 25C1 11.7452 11.7452 1 25 1C38.2548 1 49 11.7452 49 25Z",
    stroke: "#197BBD",
    strokeWidth: "2"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    d: "M15 24.5113L22.3067 31.818L35.1247 19",
    stroke: "#197BBD",
    strokeWidth: "2"
  }));
}

function CancelledCircleIcon() {
  return /*#__PURE__*/_react["default"].createElement("svg", {
    width: "50",
    height: "50",
    viewBox: "0 0 50 50",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M49 25C49 38.2548 38.2548 49 25 49C11.7452 49 1 38.2548 1 25C1 11.7452 11.7452 1 25 1C38.2548 1 49 11.7452 49 25Z",
    stroke: "#197BBD",
    strokeWidth: "2"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    d: "M39 12L11.9999 39",
    stroke: "#197BBD",
    strokeWidth: "2"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    d: "M12 12L39.0001 39.0001",
    stroke: "#197BBD",
    strokeWidth: "2"
  }));
}

function WarningCircleIcon() {
  return /*#__PURE__*/_react["default"].createElement("svg", {
    width: "50",
    height: "50",
    viewBox: "0 0 50 50",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    d: "M49 25C49 38.2548 38.2548 49 25 49C11.7452 49 1 38.2548 1 25C1 11.7452 11.7452 1 25 1C38.2548 1 49 11.7452 49 25Z",
    stroke: "#BBBBBB",
    strokeWidth: "2"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    d: "M25 11V30",
    stroke: "#BBBBBB",
    strokeWidth: "2",
    "stroke-linecap": "square"
  }), /*#__PURE__*/_react["default"].createElement("path", {
    "fill-rule": "evenodd",
    "clip-rule": "evenodd",
    d: "M25 39C25.8284 39 26.5 38.3284 26.5 37.5C26.5 36.6716 25.8284 36 25 36C24.1716 36 23.5 36.6716 23.5 37.5C23.5 38.3284 24.1716 39 25 39Z",
    fill: "#BBBBBB"
  }));
}