"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptionList = OptionList;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Heading = require("../Heading");

var _VisuallyHidden = require("../VisuallyHidden");

var _Theme = require("../Theme");

var _context = require("./context");

var _OptionList = _interopRequireDefault(require("./OptionList.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function OptionList(_ref) {
  var id = _ref.id,
      selectedItems = _ref.selectedItems,
      onChange = _ref.onChange,
      title = _ref.title,
      titleHidden = _ref.titleHidden,
      _ref$allowMultiple = _ref.allowMultiple,
      allowMultiple = _ref$allowMultiple === void 0 ? false : _ref$allowMultiple,
      children = _ref.children;
  var onChangeRef = (0, _react.useRef)(onChange);
  onChangeRef.current = onChange;
  var contextValue = (0, _react.useMemo)(function () {
    return {
      id: id,
      selectedItems: selectedItems,
      allowMultiple: allowMultiple,

      get onChange() {
        return onChangeRef.current;
      }

    };
  }, [allowMultiple, id, selectedItems]);
  var titleMarkup = title && (titleHidden ? /*#__PURE__*/_react["default"].createElement(_VisuallyHidden.VisuallyHidden, null, /*#__PURE__*/_react["default"].createElement("legend", null, title)) : /*#__PURE__*/_react["default"].createElement("legend", {
    className: _OptionList["default"].Title
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3,
    role: "presentation"
  }, title)));

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.optionList,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.background,
      background = _useThemeConfiguratio3 === void 0 ? 'surfaceTertiary' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.gap,
      gap = _useThemeConfiguratio4 === void 0 ? 'none' : _useThemeConfiguratio4;

  var className = (0, _cssUtilities.classNames)(_OptionList["default"].OptionList, background && _OptionList["default"][(0, _cssUtilities.variationName)('OptionList-background', background)], gap === 'none' && _OptionList["default"].isContainer);
  return /*#__PURE__*/_react["default"].createElement(_context.OptionListContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/_react["default"].createElement("fieldset", null, titleMarkup, /*#__PURE__*/_react["default"].createElement("div", {
    className: className
  }, children)));
}