"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Radio = Radio;
exports.RadioControl = void 0;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _HiddenForAccessibility = require("../HiddenForAccessibility");

var _VisuallyHidden = require("../VisuallyHidden");

var _Theme = require("../Theme");

var _id = require("../../utilities/id");

var _Radio = _interopRequireDefault(require("./Radio.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var createId = (0, _id.createIdCreator)('Radio');

function Radio(_ref) {
  var explicitId = _ref.id,
      accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["id", "accessibilityLabel", "children"]);

  var id = (0, _id.useId)(explicitId, createId);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _Radio["default"].Wrapper
  }, /*#__PURE__*/_react["default"].createElement(RadioControl, Object.assign({
    id: id
  }, rest)), /*#__PURE__*/_react["default"].createElement("label", {
    htmlFor: id,
    className: _Radio["default"].Label
  }, accessibilityLabel ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_VisuallyHidden.VisuallyHidden, null, accessibilityLabel), /*#__PURE__*/_react["default"].createElement(_HiddenForAccessibility.HiddenForAccessibility, null, children)) : children));
}

var RadioControl = function RadioControl(_ref2) {
  var id = _ref2.id,
      name = _ref2.name,
      _ref2$value = _ref2.value,
      value = _ref2$value === void 0 ? false : _ref2$value,
      _ref2$checked = _ref2.checked,
      checked = _ref2$checked === void 0 ? value : _ref2$checked,
      disabled = _ref2.disabled,
      _onChange = _ref2.onChange;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.radio,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.background,
      background = _useThemeConfiguratio3 === void 0 ? 'surfaceTertiary' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.borderColor,
      borderColor = _useThemeConfiguratio4 === void 0 ? 'base' : _useThemeConfiguratio4;

  var className = (0, _cssUtilities.classNames)(_Radio["default"].Input, _Radio["default"][(0, _cssUtilities.variationName)('Input-background', background)], _Radio["default"][(0, _cssUtilities.variationName)('Input-borderColor', borderColor)]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _Radio["default"].Radio
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: "radio",
    id: id,
    name: name,
    checked: checked,
    disabled: disabled,
    onChange: function onChange(_ref3) {
      var currentTarget = _ref3.currentTarget;
      _onChange === null || _onChange === void 0 ? void 0 : _onChange(currentTarget.checked);
    },
    className: className
  }));
};

exports.RadioControl = RadioControl;