"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withTooltip = exports.textarea = exports.errorState = exports.prefilledContent = exports.inputTypeTelephone = exports.inputTypeEmail = exports.inputTypeNumber = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _TextField = require("./TextField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _TextField.TextField,
  title: 'TextField',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('textFields')]
};
var _default = meta;
exports["default"] = _default;
var defaultProps = {
  id: 'field',
  label: 'Label'
};

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, defaultProps);
};

exports.defaultState = defaultState;

var inputTypeNumber = function inputTypeNumber() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    type: "number"
  }));
};

exports.inputTypeNumber = inputTypeNumber;

var inputTypeEmail = function inputTypeEmail() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    type: "email"
  }));
};

exports.inputTypeEmail = inputTypeEmail;

var inputTypeTelephone = function inputTypeTelephone() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    type: "telephone"
  }));
};

exports.inputTypeTelephone = inputTypeTelephone;

var prefilledContent = function prefilledContent() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    value: "Shopifolk"
  }));
};

exports.prefilledContent = prefilledContent;

var errorState = function errorState() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    error: "Enter a name"
  }));
};

exports.errorState = errorState;

var textarea = function textarea() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    multiline: true
  }));
};

exports.textarea = textarea;

var withTooltip = function withTooltip() {
  return /*#__PURE__*/_react["default"].createElement(_TextField.TextField, Object.assign({}, defaultProps, {
    tooltip: {
      label: 'More information',
      content: 'In case we need to contact you about your order'
    }
  }));
};

exports.withTooltip = withTooltip;