"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseHsl = parseHsl;
exports.toRgb = _toRgb;
exports.Hsl = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _wrapRegExp(re, groups) { _wrapRegExp = function _wrapRegExp(re, groups) { return new BabelRegExp(re, undefined, groups); }; var _RegExp = _wrapNativeSuper(RegExp); var _super = RegExp.prototype; var _groups = new WeakMap(); function BabelRegExp(re, flags, groups) { var _this = _RegExp.call(this, re, flags); _groups.set(_this, groups || _groups.get(re)); return _this; } _inherits(BabelRegExp, _RegExp); BabelRegExp.prototype.exec = function (str) { var result = _super.exec.call(this, str); if (result) result.groups = buildGroups(result, this); return result; }; BabelRegExp.prototype[Symbol.replace] = function (str, substitution) { if (typeof substitution === "string") { var groups = _groups.get(this); return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) { return "$" + groups[name]; })); } else if (typeof substitution === "function") { var _this = this; return _super[Symbol.replace].call(this, str, function () { var args = []; args.push.apply(args, arguments); if (_typeof(args[args.length - 1]) !== "object") { args.push(buildGroups(args, _this)); } return substitution.apply(this, args); }); } else { return _super[Symbol.replace].call(this, str, substitution); } }; function buildGroups(result, re) { var g = _groups.get(re); return Object.keys(g).reduce(function (groups, name) { groups[name] = result[g[name]]; return groups; }, Object.create(null)); } return _wrapRegExp.apply(this, arguments); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/* eslint id-length: off */
// A minimal re-implementation of https://classic.yarnpkg.com/en/package/hsluv with
// minimal bloat and some helpful types
var REF_Y = 1.0;
var REF_U = 0.19783000664283;
var REF_V = 0.46831999493879;
var MATRIX = [[3.240969941904521, -1.537383177570093, -0.498610760293], [-0.96924363628087, 1.87596750150772, 0.041555057407175], [0.055630079696993, -0.20397695888897, 1.056971514242878]];
var KAPPA = 903.2962962;
var EPSILON = 0.0088564516;

var Hsl = /*#__PURE__*/function () {
  function Hsl(h, s, l) {
    _classCallCheck(this, Hsl);

    this.h = h;
    this.s = s;
    this.l = l;
  }

  _createClass(Hsl, [{
    key: "adjust",
    value: function adjust(_ref) {
      var _h, _s, _l;

      var h = _ref.h,
          s = _ref.s,
          l = _ref.l;
      return new Hsl((_h = h === null || h === void 0 ? void 0 : h(this.h)) !== null && _h !== void 0 ? _h : this.h, (_s = s === null || s === void 0 ? void 0 : s(this.s)) !== null && _s !== void 0 ? _s : this.s, (_l = l === null || l === void 0 ? void 0 : l(this.l)) !== null && _l !== void 0 ? _l : this.l);
    }
  }, {
    key: "toRgb",
    value: function toRgb() {
      return _toRgb(this);
    }
  }]);

  return Hsl;
}();

exports.Hsl = Hsl;

var HSL_REGEX = /*#__PURE__*/_wrapRegExp(/hsl\([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*([0-9]+),[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*([0-9]+)%,[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]([0-9]+)%\)/, {
  h: 1,
  s: 2,
  l: 3
});

function parseHsl(color) {
  var match = color.match(HSL_REGEX);
  if (match == null) throw new Error("Invalid HSL value: ".concat(color));
  var _ref2 = match.groups,
      h = _ref2.h,
      s = _ref2.s,
      l = _ref2.l;
  var parsedHue = h ? parseInt(h, 10) : NaN;
  var parsedSaturation = s ? parseInt(s, 10) : NaN;
  var parsedLightness = l ? parseInt(l, 10) : NaN;

  if (Number.isNaN(parsedHue) || Number.isNaN(parsedSaturation) || Number.isNaN(parsedLightness)) {
    throw new Error("Invalid HSL value: ".concat(color));
  }

  return new Hsl(parsedHue, parsedSaturation, parsedLightness);
}

function _toRgb(_ref3) {
  var h = _ref3.h,
      s = _ref3.s,
      l = _ref3.l;
  return "rgb(".concat(lchToRgb.apply(void 0, _toConsumableArray(hsluvToLch(h, s, l))).join(','), ")");
}

function lchToRgb(l, c, h) {
  return xyzToRgb.apply(void 0, _toConsumableArray(luvToXyz.apply(void 0, _toConsumableArray(lchToLuv(l, c, h)))));
}

function xyzToRgb() {
  for (var _len = arguments.length, xyz = new Array(_len), _key = 0; _key < _len; _key++) {
    xyz[_key] = arguments[_key];
  }

  return [toRgbChannel(fromLinear(dotProduct(MATRIX[0], xyz))), toRgbChannel(fromLinear(dotProduct(MATRIX[1], xyz))), toRgbChannel(fromLinear(dotProduct(MATRIX[2], xyz)))];
}

function toRgbChannel(percentage) {
  return Math.round(percentage * 255);
}

function dotProduct(a, b) {
  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}

function fromLinear(c) {
  if (c <= 0.0031308) {
    return 12.92 * c;
  } else {
    return 1.055 * Math.pow(c, 0.416666666666666685) - 0.055;
  }
}

function lchToLuv(l, c, h) {
  var hrad = h / 360.0 * 2 * Math.PI;
  return [l, Math.cos(hrad) * c, Math.sin(hrad) * c];
}

function luvToXyz(l, u, v) {
  if (l === 0) {
    return [0, 0, 0];
  }

  var varU = u / (13 * l) + REF_U;
  var varV = v / (13 * l) + REF_V;
  var y = lToY(l);
  var x = 0 - 9 * y * varU / ((varU - 4) * varV - varU * varV);
  return [x, y, (9 * y - 15 * varV * y - varV * x) / (3 * varV)];
}

function lToY(l) {
  if (l <= 8) {
    return REF_Y * l / KAPPA;
  } else {
    return REF_Y * Math.pow((l + 16) / 116, 3);
  }
}

function hsluvToLch(h, s, l) {
  if (l > 99.9999999) {
    return [100, 0, h];
  }

  if (l < 0.00000001) {
    return [0, 0, h];
  }

  var max = maxChromaForLH(l, h);
  var c = max / 100 * s;
  return [l, c, h];
}

function maxChromaForLH(l, h) {
  var hrad = h / 360 * Math.PI * 2;
  var bounds = getBounds(l);
  return Math.min.apply(Math, _toConsumableArray(bounds.map(function (bound) {
    return lengthOfRayUntilIntersect(hrad, bound);
  }).filter(function (length) {
    return length > 0;
  })));
}

function lengthOfRayUntilIntersect(theta, line) {
  return line.intercept / (Math.sin(theta) - line.slope * Math.cos(theta));
}

function getBounds(l) {
  var bounds = [];
  var sub1 = Math.pow(l + 16, 3) / 1560896;
  var sub2 = sub1 > EPSILON ? sub1 : l / KAPPA;

  var _iterator = _createForOfIteratorHelper(MATRIX),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _slicedToArray(_step.value, 3),
          m1 = _step$value[0],
          m2 = _step$value[1],
          m3 = _step$value[2];

      for (var _i2 = 0, _arr2 = [0, 1]; _i2 < _arr2.length; _i2++) {
        var t = _arr2[_i2];
        var top1 = (284517 * m1 - 94839 * m3) * sub2;
        var top2 = (838422 * m3 + 769860 * m2 + 731718 * m1) * l * sub2 - 769860 * t * l;
        var bottom = (632260 * m3 - 126452 * m2) * sub2 + 126452 * t;
        bounds.push({
          slope: top1 / bottom,
          intercept: top2 / bottom
        });
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return bounds;
}