import React from 'react';
import { mountWithContext } from '../../test-utilities';
import { TextField } from '../TextField';
import { Select } from '../Select';
import { FormLayout, FormLayoutGroup } from './FormLayout';
describe('<FormLayout />', function () {
  it('renders its children', function () {
    var selectCountryProps = {
      id: 'select',
      name: 'country',
      label: 'Country',
      options: [{
        value: 'CA',
        label: 'Canada'
      }, {
        value: 'US',
        label: 'United States'
      }, {
        value: 'UK',
        label: 'United Kingdom'
      }]
    };
    var selectProvinceProps = {
      id: 'select',
      name: 'province',
      label: 'Province',
      options: [{
        value: 'QC',
        label: 'Quebec'
      }, {
        value: 'ON',
        label: 'Ontario'
      }, {
        value: 'PEI',
        label: 'Prince Edward Island'
      }]
    };
    var formLayout = mountWithContext( /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(FormLayoutGroup, null, /*#__PURE__*/React.createElement(Select, selectCountryProps), /*#__PURE__*/React.createElement(Select, selectProvinceProps)), /*#__PURE__*/React.createElement(TextField, {
      name: "address1",
      id: "address1",
      label: "Address"
    }), /*#__PURE__*/React.createElement(TextField, {
      name: "address2",
      id: "address2",
      label: "Apartment, suite, etc."
    })));
    expect(formLayout).toContainReactComponentTimes(FormLayoutGroup, 1);
    expect(formLayout).toContainReactComponentTimes(TextField, 2);
  });
});