import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { caretDown, cart, checkmark, chevronDown, chevronUp, chevronRight, chevronLeft, close, critical, discount, delivered, delivery, disabled, errorFill, info, lock, questionFill, ship, spinner, spinnerSmall, success, warning, warningFill } from '../../icons';
import styles from './Icon.css';
var BUNDLED_ICONS = {
  caretDown: caretDown,
  cart: cart,
  checkmark: checkmark,
  chevronDown: chevronDown,
  chevronUp: chevronUp,
  chevronRight: chevronRight,
  chevronLeft: chevronLeft,
  close: close,
  critical: critical,
  discount: discount,
  delivered: delivered,
  delivery: delivery,
  disabled: disabled,
  errorFill: errorFill,
  info: info,
  lock: lock,
  questionFill: questionFill,
  spinner: spinner,
  spinnerSmall: spinnerSmall,
  success: success,
  ship: ship,
  warning: warning,
  warningFill: warningFill
};
export function Icon(_ref) {
  var source = _ref.source,
      color = _ref.color,
      size = _ref.size,
      accessibilityLabel = _ref.accessibilityLabel;
  var className = classNames(styles.Icon, color && styles[variationName('color', color)], size && styles[variationName('size', size)]);
  var contentMarkup;

  if (source === 'placeholder') {
    contentMarkup = /*#__PURE__*/React.createElement("div", {
      className: styles.Placeholder
    });
  } else {
    var SourceComponent = BUNDLED_ICONS[source];
    contentMarkup = /*#__PURE__*/React.createElement(SourceComponent, {
      className: styles.Svg,
      focusable: "false",
      "aria-hidden": "true"
    });
  }

  return /*#__PURE__*/React.createElement("span", {
    className: className,
    "aria-label": accessibilityLabel
  }, contentMarkup);
}