function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { HiddenForAccessibility } from '../HiddenForAccessibility';
import { VisuallyHidden } from '../VisuallyHidden';
import { useThemeConfiguration } from '../Theme';
import { useId, createIdCreator } from '../../utilities/id';
import styles from './Radio.css';
var createId = createIdCreator('Radio');
export function Radio(_ref) {
  var explicitId = _ref.id,
      accessibilityLabel = _ref.accessibilityLabel,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["id", "accessibilityLabel", "children"]);

  var id = useId(explicitId, createId);
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Wrapper
  }, /*#__PURE__*/React.createElement(RadioControl, Object.assign({
    id: id
  }, rest)), /*#__PURE__*/React.createElement("label", {
    htmlFor: id,
    className: styles.Label
  }, accessibilityLabel ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(VisuallyHidden, null, accessibilityLabel), /*#__PURE__*/React.createElement(HiddenForAccessibility, null, children)) : children));
}
export var RadioControl = function RadioControl(_ref2) {
  var id = _ref2.id,
      name = _ref2.name,
      _ref2$value = _ref2.value,
      value = _ref2$value === void 0 ? false : _ref2$value,
      _ref2$checked = _ref2.checked,
      checked = _ref2$checked === void 0 ? value : _ref2$checked,
      disabled = _ref2.disabled,
      _onChange = _ref2.onChange;

  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.radio,
      _useThemeConfiguratio3 = _useThemeConfiguratio2.background,
      background = _useThemeConfiguratio3 === void 0 ? 'surfaceTertiary' : _useThemeConfiguratio3,
      _useThemeConfiguratio4 = _useThemeConfiguratio2.borderColor,
      borderColor = _useThemeConfiguratio4 === void 0 ? 'base' : _useThemeConfiguratio4;

  var className = classNames(styles.Input, styles[variationName('Input-background', background)], styles[variationName('Input-borderColor', borderColor)]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles.Radio
  }, /*#__PURE__*/React.createElement("input", {
    type: "radio",
    id: id,
    name: name,
    checked: checked,
    disabled: disabled,
    onChange: function onChange(_ref3) {
      var currentTarget = _ref3.currentTarget;
      _onChange === null || _onChange === void 0 ? void 0 : _onChange(currentTarget.checked);
    },
    className: className
  }));
};