import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { createIdCreator, useId } from '../../utilities/id';
import { utilityDefaultBorderColor } from '../../utilities/legacy';
import { Heading } from '../Heading';
import { HeadingGroup } from '../HeadingGroup';
import { VisuallyHidden } from '../VisuallyHidden';
import styles from './ResourceList.css';
var createId = createIdCreator('ResourceList');
export function ResourceList(_ref) {
  var children = _ref.children,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? 'none' : _ref$border,
      title = _ref.title,
      titleHidden = _ref.titleHidden;
  var id = useId(undefined, createId);
  var className = classNames(styles.ResourceList, utilityDefaultBorderColor, border && styles[variationName('border', border)]);
  var titleMarkup = title ? /*#__PURE__*/React.createElement(Heading, {
    id: id
  }, title) : null;
  return /*#__PURE__*/React.createElement(React.Fragment, null, title && titleHidden ? /*#__PURE__*/React.createElement(VisuallyHidden, null, titleMarkup) : titleMarkup, /*#__PURE__*/React.createElement(HeadingGroup, null, /*#__PURE__*/React.createElement("div", {
    role: "table",
    "aria-labelledby": id,
    className: className
  }, children)));
}
export function ResourceListHeader(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React.createElement("div", {
    role: "row",
    className: styles.ResourceListHeader
  }, children);
}
export function ResourceListHeaderContent(_ref3) {
  var children = _ref3.children,
      primary = _ref3.primary,
      hidden = _ref3.hidden;
  return /*#__PURE__*/React.createElement("div", {
    role: "columnheader",
    className: primary ? styles['ResourceListHeaderContent-isPrimary'] : undefined
  }, hidden ? /*#__PURE__*/React.createElement(VisuallyHidden, null, children) : children);
}