import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { ReviewItem, ReviewBlock } from './ReviewItem';
var meta = {
  component: ReviewItem,
  title: 'ReviewItem',
  decorators: [withKnobs, themeWithKnobs('reviewBlock')]
};
export default meta;
export var defaultState = function defaultState() {
  return /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Contact"
  }, "snowdevil@shopify.com");
};
export var withLink = function withLink() {
  return /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Contact",
    to: "/shipping",
    linkLabel: "Change"
  }, "snowdevil@shopify.com");
};
export var withAriaLabelForLink = function withAriaLabelForLink() {
  return /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Contact",
    to: "/shipping",
    linkLabel: "Change",
    linkAriaLabel: "Change contact information"
  }, "snowdevil@shopify.com");
};
export var reviewBlock = function reviewBlock() {
  return /*#__PURE__*/React.createElement(ReviewBlock, {
    title: "Review"
  }, /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Contact",
    to: "/information",
    linkLabel: "Change",
    linkAriaLabel: "Change contact information"
  }, "snowdevil@shopify.com"), /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Ship to",
    to: "/information",
    linkLabel: "Change",
    linkAriaLabel: "Change shipping address"
  }, "490 Rue de la Gaucheti\xE8re O, Montr\xE9al, QC H2Z 0B3"), /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Method",
    to: "/shipping",
    linkLabel: "Change",
    linkAriaLabel: "Change shipping method"
  }, "Standard - ", /*#__PURE__*/React.createElement("strong", null, "$14.90")));
};
export var reviewBlockWithHiddenTitle = function reviewBlockWithHiddenTitle() {
  return /*#__PURE__*/React.createElement(ReviewBlock, {
    title: "Review your information",
    titleHidden: true
  }, /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Contact",
    to: "/information",
    linkLabel: "Change",
    linkAriaLabel: "Change contact information"
  }, "snowdevil@shopify.com"), /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Ship to",
    to: "/information",
    linkLabel: "Change",
    linkAriaLabel: "Change shipping address"
  }, "490 Rue de la Gaucheti\xE8re O, Montr\xE9al, QC H2Z 0B3"), /*#__PURE__*/React.createElement(ReviewItem, {
    label: "Method",
    to: "/shipping",
    linkLabel: "Change",
    linkAriaLabel: "Change shipping method"
  }, "Standard - ", /*#__PURE__*/React.createElement("strong", null, "$14.90")));
};