import React from 'react';
import { mount } from '@quilted/react-testing/dom';
import { Stepper } from './Stepper';
import { StepperContext } from './context';
import { StepperStep } from '.';
describe('<Stepper />', function () {
  it('renders <StepperStep /> children', function () {
    var stepper = mount( /*#__PURE__*/React.createElement(Stepper, null, /*#__PURE__*/React.createElement(StepperStep, {
      id: "step1",
      icon: "checkmark",
      label: "Step 1",
      state: "State 1"
    }), /*#__PURE__*/React.createElement(StepperStep, {
      id: "step2",
      icon: "checkmark",
      label: "Step 2",
      state: "State 2"
    })));
    expect(stepper).toContainReactComponent(StepperStep);
    expect(stepper).toContainReactComponentTimes(StepperStep, 2);
  });
  it('wraps <StepperStep /> children with StepperContext', function () {
    var stepper = mount( /*#__PURE__*/React.createElement(Stepper, {
      activeStep: "step2"
    }, /*#__PURE__*/React.createElement(StepperStep, {
      id: "step1",
      icon: "checkmark",
      label: "Step 1",
      state: "State 1"
    }), /*#__PURE__*/React.createElement(StepperStep, {
      id: "step2",
      icon: "checkmark",
      label: "Step 2",
      state: "State 3"
    }), /*#__PURE__*/React.createElement(StepperStep, {
      id: "step3",
      icon: "checkmark",
      label: "Step 3",
      state: "State 3"
    })));
    expect(stepper).toProvideReactContext(StepperContext, {
      steps: {
        step1: {
          active: false,
          completed: true
        },
        step2: {
          active: true,
          completed: false
        },
        step3: {
          active: false,
          completed: false
        }
      }
    });
  });
});