import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { BlockStack, Bookend, Button, ButtonGroup, Checkbox, FormLayoutGroup, FormLayout, Heading, HeadingGroup, Image, InlineStack, Link, Radio, Select, Separator, SkeletonText, Text, TextBlock, TextContainer, TextField
/* Tiles,
Tile */
} from '..';
import { themeWithKnobs } from '.';
var meta = {
  title: 'Playground',
  decorators: [withKnobs, themeWithKnobs()]
};
export default meta;

function Content() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      backgroundColor: 'lightgrey'
    }
  }, "Content block");
}

export var argoComponents = function argoComponents() {
  return /*#__PURE__*/React.createElement(BlockStack, {
    spacing: "xloose"
  }, /*#__PURE__*/React.createElement(Heading, null, "BlockStack"), /*#__PURE__*/React.createElement(BlockStack, {
    spacing: "xtight"
  }, /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null)), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Bookend"), /*#__PURE__*/React.createElement(Bookend, {
    trailing: true
  }, /*#__PURE__*/React.createElement(TextField, {
    label: "Name"
  }), /*#__PURE__*/React.createElement(Button, null, "Hello, world!")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "ButtonGroup"), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, null, "Hello, world!"), /*#__PURE__*/React.createElement(Button, null, "Hello, world!"), /*#__PURE__*/React.createElement(Button, null, "Hello, world!")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Checkbox"), /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox1",
    name: "checkboxchoices"
  }, "Save this information for next time"), /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox2",
    name: "checkboxchoices"
  }, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?"), /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox3",
    name: "checkboxchoices"
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Lorem ipsum dolor sit amet"), /*#__PURE__*/React.createElement(Text, null, "consectetur adipisicing elit"))), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "FormLayout"), /*#__PURE__*/React.createElement(FormLayout, null, /*#__PURE__*/React.createElement(FormLayoutGroup, null, /*#__PURE__*/React.createElement(Select, {
    id: "select",
    name: "country",
    label: "Country",
    options: [{
      value: 'CA',
      label: 'Canada'
    }, {
      value: 'US',
      label: 'United States'
    }, {
      value: 'UK',
      label: 'United Kingdom'
    }]
  }), /*#__PURE__*/React.createElement(Select, {
    id: "select",
    name: "province",
    label: "Province",
    options: [{
      value: 'QC',
      label: 'Quebec'
    }, {
      value: 'ON',
      label: 'Ontario'
    }, {
      value: 'PEI',
      label: 'Prince Edward Island'
    }]
  })), /*#__PURE__*/React.createElement(TextField, {
    label: "Address",
    name: "address1",
    id: "address1"
  }), /*#__PURE__*/React.createElement(TextField, {
    label: "Apartment, suite, etc.",
    name: "address2",
    id: "address2"
  })), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Heading"), /*#__PURE__*/React.createElement(HeadingGroup, null, /*#__PURE__*/React.createElement(Heading, {
    level: 1
  }, "Hello, world!"), /*#__PURE__*/React.createElement(Heading, {
    level: 2
  }, "Hello, world!"), /*#__PURE__*/React.createElement(Heading, {
    level: 3
  }, "Hello, world!")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Image"), /*#__PURE__*/React.createElement("div", {
    style: {
      width: 512
    }
  }, /*#__PURE__*/React.createElement(Image, {
    source: "http://placekitten.com/g/512/256",
    sources: [{
      source: 'http://placekitten.com/g/512/256',
      resolution: 1
    }, {
      source: 'http://placekitten.com/g/1024/512',
      resolution: 2
    }],
    aspectRatio: 1,
    fit: "contain",
    bordered: true,
    description: "placekitten.com"
  })), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "InlineStack"), /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), " ", /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Content, null)), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Link"), /*#__PURE__*/React.createElement(InlineStack, null, /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    external: false
  }, "Internal link"), /*#__PURE__*/React.createElement(Link, {
    to: "https://shopify.com",
    external: true
  }, "External link"), /*#__PURE__*/React.createElement(Link, {
    to: undefined
  }, "Link without Url")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Radio"), /*#__PURE__*/React.createElement("div", {
    style: {
      width: '250px'
    }
  }, /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Radio, {
    id: "radio1",
    name: "radiochoices"
  }, "Save this information for next time"), /*#__PURE__*/React.createElement(Radio, {
    id: "radio2",
    name: "radiochoices"
  }, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?"), /*#__PURE__*/React.createElement(Radio, {
    id: "radio3",
    name: "radiochoices"
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Lorem ipsum dolor sit amet"), /*#__PURE__*/React.createElement(Text, null, "consectetur adipisicing elit")))), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Select"), /*#__PURE__*/React.createElement(Select, {
    label: 'Country',
    options: [{
      value: 'CA',
      label: 'Canada'
    }, {
      value: 'US',
      label: 'United States'
    }, {
      value: 'UK',
      label: 'United Kingdom'
    }]
  }), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Separator"), /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Content, null), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Content, null)), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "SkeletonText"), /*#__PURE__*/React.createElement(SkeletonText, {
    lines: 3
  }), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Text"), /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Text, null, "Default"), /*#__PURE__*/React.createElement(Text, {
    subdued: true
  }, "Subdued"), /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Emphasized")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "TextBlock"), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(TextBlock, null, "Default"), /*#__PURE__*/React.createElement(TextBlock, {
    subdued: true
  }, "Subdued"), /*#__PURE__*/React.createElement(TextBlock, {
    emphasized: true
  }, "Emphasized")), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "TextContainer"), /*#__PURE__*/React.createElement(TextContainer, null, /*#__PURE__*/React.createElement(ExampleText, null), /*#__PURE__*/React.createElement(ExampleText, null), /*#__PURE__*/React.createElement(ExampleText, null), /*#__PURE__*/React.createElement(ExampleText, null)), /*#__PURE__*/React.createElement(Separator, null), /*#__PURE__*/React.createElement(Heading, null, "Tiles"));
};
/* function ExampleTile() {
  return (
    <Tile>
      <div
        style={{
          backgroundColor: 'lightgrey',
          border: '1px #000 solid',
          padding: '1em',
        }}
      >
        Content block
      </div>
    </Tile>
  );
} */

function ExampleText() {
  return /*#__PURE__*/React.createElement(TextBlock, null, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Beatae enim veniam natus facilis. Nemo nisi assumenda alias dolore saepe quia! Sed perspiciatis veritatis nesciunt vitae nobis distinctio quod illo neque?");
}