"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UnstyledLink = UnstyledLink;

var _react = _interopRequireDefault(require("react"));

var _AppContext = require("../../../AppContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function UnstyledLink({
  children,
  className,
  to,
  external,
  id,
  onPress
}) {
  const LinkComponent = (0, _AppContext.useLinkComponent)();

  if (LinkComponent) {
    return /*#__PURE__*/_react.default.createElement(LinkComponent, {
      to: to,
      onClick: onPress,
      external: external,
      id: id,
      className: className
    }, children);
  }

  const target = external ? '_blank' : undefined;
  const rel = external ? 'noopener noreferrer' : undefined;
  return /*#__PURE__*/_react.default.createElement("a", {
    href: to,
    onClick: onPress,
    target: target,
    rel: rel,
    id: id,
    className: className
  }, children);
}