"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.disabledAndChecked = exports.withAccessibilityLabel = exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _BlockStack = require("../BlockStack");

var _Radio = require("./Radio");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _Radio.Radio,
  title: 'Radio',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('radio')]
};
var _default = meta;
exports.default = _default;
const defaultProps = {
  name: 'Radio',
  children: 'Save this information for next time'
};

const defaultState = () => /*#__PURE__*/_react.default.createElement("div", {
  style: {
    width: '250px'
  }
}, /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Radio.Radio, {
  id: "radio1",
  name: "radiochoices"
}, "Save this information for next time"), /*#__PURE__*/_react.default.createElement(_Radio.Radio, {
  id: "radio2",
  name: "radiochoices"
}, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?"), /*#__PURE__*/_react.default.createElement(_Radio.Radio, {
  id: "radio3",
  name: "radiochoices"
}, /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, "Lorem ipsum dolor sit amet"), /*#__PURE__*/_react.default.createElement(_Text.Text, null, "consectetur adipisicing elit"))));

exports.defaultState = defaultState;

const withAccessibilityLabel = () => /*#__PURE__*/_react.default.createElement(_Radio.Radio, Object.assign({}, defaultProps, {
  accessibilityLabel: "This is a description for screen readers"
}));

exports.withAccessibilityLabel = withAccessibilityLabel;

const disabledAndChecked = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Radio.Radio, Object.assign({}, defaultProps, {
  disabled: true
})), /*#__PURE__*/_react.default.createElement(_Radio.Radio, Object.assign({}, defaultProps, {
  checked: true,
  disabled: true
})));

exports.disabledAndChecked = disabledAndChecked;