"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResourceItemContent = ResourceItemContent;
exports.ResourceItem = ResourceItem;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _legacy = require("../../utilities/legacy");

var _VisuallyHidden = require("../VisuallyHidden");

var _ResourceItem = _interopRequireDefault(require("./ResourceItem.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ResourceItemContent({
  children,
  primary,
  hidden
}) {
  return /*#__PURE__*/_react.default.createElement("div", {
    role: "cell",
    className: primary ? (0, _cssUtilities.classNames)(_ResourceItem.default['ResourceItemContent-isPrimary'], _ResourceItem.default.ResourceItemContent) : _ResourceItem.default.ResourceItemContent
  }, hidden ? /*#__PURE__*/_react.default.createElement(_VisuallyHidden.VisuallyHidden, null, children) : children);
}

function ResourceItem({
  children
}) {
  return /*#__PURE__*/_react.default.createElement("div", {
    role: "row",
    className: (0, _cssUtilities.classNames)(_ResourceItem.default.ResourceItem, _legacy.utilityDefaultBorderColor)
  }, children);
}