"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const FlagIcon_1 = require("./FlagIcon");
describe('<FlagIcon />', () => {
    it('renders an <img>', () => {
        const flagIcon = dom_1.mount(<FlagIcon_1.FlagIcon countryCode="ca"/>);
        expect(flagIcon).toContainReactComponent('img');
    });
    it('sets src and an alt attributes', () => {
        const flagIcon = dom_1.mount(<FlagIcon_1.FlagIcon countryCode="ca" accessibilityLabel="Canada"/>);
        expect(flagIcon).toContainReactComponent('img', {
            src: 'ca.svg',
            alt: 'Canada',
        });
    });
});
