"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MoneyLineSeparator = exports.MoneyLine = void 0;
const react_1 = __importDefault(require("react"));
const View_1 = require("../View");
const Text_1 = require("../Text");
const TextBlock_1 = require("../TextBlock");
const MoneyLine_css_1 = __importDefault(require("./MoneyLine.css"));
function MoneyLine({ label, value, subdued, children }) {
    return (<div className={MoneyLine_css_1.default.MoneyLine} role="row">
      <div role="rowheader">
        <View_1.View>
          <Text_1.Text>{label}</Text_1.Text>
          {children}
        </View_1.View>
      </div>
      <div role="cell">
        <TextBlock_1.TextBlock subdued={subdued} emphasized={!subdued}>
          {value}
        </TextBlock_1.TextBlock>
      </div>
    </div>);
}
exports.MoneyLine = MoneyLine;
function MoneyLineSeparator() {
    return <div className={MoneyLine_css_1.default.MoneyLineSeparator}/>;
}
exports.MoneyLineSeparator = MoneyLineSeparator;
