"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomPropertiesFallback = void 0;
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
const legacyStyles = __importStar(require("../../../../utilities/legacy"));
exports.CustomPropertiesFallback = react_1.memo(function CustomPropertiesFallback() {
    const theme = hooks_1.useTheme();
    const [customProperties, setCustomProperties] = react_1.useState(theme.customProperties);
    react_1.useEffect(() => {
        return theme.on('preview', (customProperties) => {
            setCustomProperties((existing) => (Object.assign(Object.assign({}, existing), customProperties)));
        });
    }, [theme]);
    const css = react_1.useMemo(() => toCss(customProperties), [customProperties]);
    return <style dangerouslySetInnerHTML={{ __html: css }}/>;
});
function toCss(customProperties) {
    return cssFromObject({
        [`.${legacyStyles.button}`]: {
            color: customProperties.colorPrimaryText,
            background: customProperties.colorPrimary,
        },
        [`.${legacyStyles.button}:hover`]: {
            background: customProperties.colorPrimaryHovered,
        },
        [`.${legacyStyles.button}:active`]: {
            background: customProperties.colorPrimaryPressed,
        },
        [`.${legacyStyles.colorCanvas}`]: {
            color: customProperties.colorCanvasText,
            'border-color': customProperties.colorCanvasBorder,
            'background-color': customProperties.colorCanvas,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorCanvasBorder,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorCanvasTextSubdued,
        },
        [`.${legacyStyles.colorCanvas} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorCanvasTextEmphasized,
        },
        [`.${legacyStyles.colorSurfacePrimary}`]: {
            color: customProperties.colorSurfacePrimaryText,
            'border-color': customProperties.colorSurfacePrimaryBorder,
            'background-color': customProperties.colorSurfacePrimary,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfacePrimaryBorder,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfacePrimaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfacePrimary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfacePrimaryTextEmphasized,
        },
        [`.${legacyStyles.colorSurfaceSecondary}`]: {
            color: customProperties.colorSurfaceSecondaryText,
            'border-color': customProperties.colorSurfaceSecondaryBorder,
            'background-color': customProperties.colorSurfaceSecondary,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfaceSecondaryBorder,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfaceSecondaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfaceSecondary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfaceSecondaryTextEmphasized,
        },
        [`.${legacyStyles.colorSurfaceTertiary}`]: {
            color: customProperties.colorSurfaceTertiaryText,
            'border-color': customProperties.colorSurfaceTertiaryBorder,
            'background-color': customProperties.colorSurfaceTertiary,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultBorderColor}`]: {
            'border-color': customProperties.colorSurfaceTertiaryBorder,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorSubdued}`]: {
            color: customProperties.colorSurfaceTertiaryTextSubdued,
        },
        [`.${legacyStyles.colorSurfaceTertiary} .${legacyStyles.utilityDefaultTextColorEmphasized}`]: {
            color: customProperties.colorSurfaceTertiaryTextEmphasized,
        },
    });
}
function cssFromObject(cssObject) {
    const selectors = [];
    for (const selector of Object.keys(cssObject)) {
        const propertyValues = [];
        for (const property of Object.keys(cssObject[selector])) {
            const value = cssObject[selector][property];
            if (value)
                propertyValues.push(`${property}: ${value} !important;`);
        }
        if (propertyValues.length > 0)
            selectors.push(`${selector} {\n  ${propertyValues.join('\n  ')}\n}`);
    }
    return selectors.join('\n');
}
