"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePrefersReducedMotion = void 0;
const react_1 = require("react");
function usePrefersReducedMotion() {
    const [prefersReducedMotion, setPrefersReducedMotion] = react_1.useState(window.matchMedia('(prefers-reduced-motion: reduce)').matches);
    react_1.useEffect(() => {
        const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
        const handleChange = () => {
            setPrefersReducedMotion(mediaQuery.matches);
        };
        mediaQuery.addListener(handleChange);
        return () => {
            mediaQuery.removeListener(handleChange);
        };
    }, []);
    return prefersReducedMotion;
}
exports.usePrefersReducedMotion = usePrefersReducedMotion;
